"use strict";
{
	const C3 = self.C3;
	C3.Plugins.Rex_Nickname.Instance = class Rex_NicknameInstance extends C3.SDKInstanceBase
	{
		constructor(inst, properties)
		{
			super(inst);
			this.nickname2objtype = {}; // {sid:_sid, index:types_by_index[_index
			this.sid2nickname = {}; // {sid:nickname}
			this.exp_LastCreatedInstUID = -1;
			globalThis.RexC2NicknameObj = this;
			if (properties)
			{
			}
		}
		Release()
		{
			super.Release();
		}
		AddNickname(nickname, objtype)
		{
			this.nickname2objtype[nickname] = {
				sid: objtype.GetSID(),
				index: -1
			};
			this.sid2nickname[objtype.GetSID().toString()] = nickname;
		}
		Nickname2Type(nickname)
		{
			var sidInfo = this.nickname2objtype[nickname];
			if (sidInfo == null)
				return null;
			var sid = sidInfo.sid;
			var objtypes = this._runtime.GetAllObjectClasses();
			var t = objtypes[sidInfo.index];
			if ((t != null) && (t.GetSID() === sid))
				return t;
			var i, len = objtypes.length;
			for (i = 0; i < len; i++) {
				t = objtypes[i];
				if (t.GetSID() === sid) {
					sidInfo.index = i;
					return t;
				}
			}
			return null;
		}
		CreateInst(nickname, x, y, layer, callback, ignore_picking)
		{
			var objtype = (typeof (nickname) == "string") ? this.Nickname2Type(nickname) :
				nickname;
			if (objtype == null)
				return null;
			var inst = globalThis.RexC2CreateObject.call(this, objtype, layer, x, y, callback, ignore_picking);
			return inst;
		}
		PickAll(nickname, family_objtype)
		{
			var objtype = this.Nickname2Type(nickname);
			if (!has_objtype(family_objtype, objtype)) {
				clean_sol(family_objtype);
			} else if (family_objtype.IsFamily()) {
				var sol = objtype.GetCurrentSol();
				var sol_save = sol.IsSelectAll();
				sol._SetSelectAll(true);
				// set sol of family_objtype
				clean_sol(family_objtype);
				extend_sol(family_objtype, sol.GetInstances());
				// recover sol
				sol._SetSelectAll(sol_save);
			} else {
				var sol = family_objtype.GetCurrentSol();
				sol._SetSelectAll(true);
			}
			return has_any_picked_inst(family_objtype);
		}
		PickMatched(_substring, family_objtype)
		{
			if (family_objtype.IsFamily()) {
				clean_sol(family_objtype);
				var nickname;
				var objtype, sol, sol_save;
				for (nickname in this.nickname2objtype) {
					if (nickname.match(_substring) == null)
						continue;
					objtype = this.Nickname2Type(nickname);
					if (!has_objtype(family_objtype, objtype))
						continue;
					sol = objtype.GetCurrentSol();
					sol_save = sol.IsSelectAll();
					sol._SetSelectAll(true);
					extend_sol(family_objtype, sol.GetInstances());
					sol._SetSelectAll(sol_save);
				}
			} else {
				var nickname = this.sid2nickname[family_objtype.GetSID()];
				if ((nickname != null) && (nickname.match(_substring) != null)) {
					var sol = family_objtype.GetCurrentSol();
					sol._SetSelectAll(true);
				} else {
					clean_sol(family_objtype);
				}
			}
			return has_any_picked_inst(family_objtype);
		}
		SaveToJson()
		{
			return {
				"sid2name": this.sid2nickname,
			};
		}
		LoadFromJson(o)
		{
			var sid2name = o["sid2name"];
			this.sid2nickname = sid2name;
			var sid, name, objtype;
			for (sid in sid2name) {
				name = sid2name[sid];
				this.nickname2objtype[name] = {
					sid: parseInt(sid, 10),
					index: -1
				};
			}
		}
		GetDebuggerProperties()
		{
			var porp = [];
			var nickname;
			for (nickname in this.nickname2objtype) {
				porp.push({
					name: this.Nickname2Type(nickname).GetName(),
					value: nickname
				});
			}
			return [{
				title: "Nickname",
				properties: porp
			}];
		}
	};
}