"use strict";
	globalThis.has_objtype = function (objfamily, objb) {
		if ((!objfamily) || (!objb))
			return false;
		else if (objfamily.IsFamily()) // family contain this objtype
			return (objfamily.GetFamilyMembers().indexOf(objb) != -1);
		else // objtype is equal
			return (objfamily === objb);
	};
	globalThis.clean_sol = function (objtype) {
		var sol = objtype.GetCurrentSol();
		sol._SetSelectAll(false);
		sol.GetInstances().length = 0; // clear contents    
	};
	globalThis.extend_sol = function (objtype, insts) {
		var sol = objtype.GetCurrentSol();
		var sol_insts = sol.GetInstances();
		sol_insts.push.apply(sol_insts, insts);
		sol._SetSelectAll(false);
	};
	globalThis.has_any_picked_inst = function (objtype) {
		return (objtype.GetCurrentSol().GetInstances().length > 0);
	};
{
	const C3 = self.C3;
	C3.Plugins.Rex_Nickname = class Rex_NicknamePlugin extends C3.SDKPluginBase
	{
		constructor(opts)
		{
			super(opts);
			(function () {
				// general CreateObject function which call a callback before "OnCreated" triggered
				if (globalThis.RexC2CreateObject != null)
					return;
				// copy from system action: CreateObject
				var CreateObject = function (obj, layer, x, y, callback, ignore_picking) {
					if (!layer || !obj)
						return;
					var inst = this._runtime.CreateInstance(obj, layer, x, y);
					if (!inst)
						return;
					this._runtime.GetEventSheetManager().BlockFlushingInstances(true);
					// call callback before "OnCreated" triggered
					if (callback)
						callback(inst);
					// call callback before "OnCreated" triggered
					inst._TriggerOnCreatedOnSelfAndRelated();
					this._runtime.GetEventSheetManager().BlockFlushingInstances(false);
					if (ignore_picking !== true) {
						// Pick just this instance
						var sol = obj.GetCurrentSol();
						sol._SetSelectAll(false);
						sol.GetInstances().length = 1;
						sol.GetInstances()[0] = inst;
						// Siblings aren't in instance lists yet, pick them manually
						if (inst.IsInContainer()) {
							for (i = 0, len = inst.GetSiblings().length; i < len; i++) {
								s = inst.GetSiblings()[i];
								sol = s.GetObjectClass().GetCurrentSol();
								sol._SetSelectAll(false);
								sol.GetInstances().length = 1;
								sol.GetInstances()[0] = s;
							}
						}
					}
					return inst;
				};
				globalThis.RexC2CreateObject = CreateObject;
			}());
		}
		Release()
		{
			super.Release();
		}
	};
}